; ==============================================================================
; The DOS test environment module.
; Copyright 2004 Emboss, all rights reserved
; See licence.txt for details.
; ==============================================================================

%macro DUMPREG16 1
  pusha
  push    ds
  mov     ax,%1
  call    DumpAX
  pop     ds
  popa
%endmacro

DumpAX:
  push    cs
  pop     ds
  mov     dx,ax
  xor     ah,ah

  mov     si,HexTbl
  mov     al,dh
  shr     al,4
  add     si,ax
  mov     al,[si]
  mov     [AXStr+5],al

  mov     si,HexTbl
  mov     al,dh
  and     al,0x0F
  add     si,ax
  mov     al,[si]
  mov     [AXStr+6],al

  mov     si,HexTbl
  mov     al,dl
  shr     al,4
  add     si,ax
  mov     al,[si]
  mov     [AXStr+7],al

  mov     si,HexTbl
  mov     al,dl
  and     al,0x0F
  add     si,ax
  mov     al,[si]
  mov     [AXStr+8],al

  mov     ah,9
  mov     dx,AXStr
  int     0x21
  ret

HexTbl:
  db  "0123456789ABCDEF"

AXStr:
  db  "AX=0x____", 0x0D, 0x0A, '$'

mod_DOS:
  SHOWSTR "mod_DOS"

  cli
  mov     ecx,0x1000000
.WaitLoop:
  dec     ecx
  jnz     .WaitLoop

  SHOWSTR "Beginning test"
  mov     [TmpDest+2],cs

  ; Emulation of what the BIOS does
  mov     ax,0x5000
  mov     ds,ax
  mov     al, 0C5h
  push    ax
  push    ds
  
  call    far [cs:TmpDest]
  SHOWSTR "Test completed"

  DUMPREG16 ds

  pop     ds
  pop     ax

  DUMPREG16 ax
  DUMPREG16 ds

%ifdef USE_KEYBOARD
  mov     al,0xAE                   ; Disable the keyboard
  call    KbdSendCmd64
  mov     al,0x60                   ; Set the controller command byte
  call    KbdSendCmd64
  mov     al,0x45                   ; normal operation
  call    KbdWrite
  mov     al,0xF4                   ; Enable the keyboard
  call    KbdSendCmd60
%endif
  sti
  
  mov     ah,0x4C
  int     0x21

TmpDest:
  dw  Start
  dw  0
