; ==============================================================================
; Forces a reflash of the ROM
; ==============================================================================

mod_ForceReflash:
  push    bp

  ; Stack looks like
  ; [sp+32] shadow source segment (ax):16
  ; [sp+30] shadow source segment (ds):16
  ; [sp+2E] cs:16
  ; [sp+2C] ip:16
  ; [sp+28] eflags:32
  ; [sp+24] eax:32
  ; [sp+20] ecx:32
  ; [sp+1C] edx:32
  ; [sp+18] ebx:32
  ; [sp+14] esp:32
  ; [sp+10] ebp:32
  ; [sp+0C] esi:32
  ; [sp+08] edi:32
  ; [sp+06] ds:16
  ; [sp+04] es:16
  ; [sp+02] ip:16
  ; [sp+00] bp:16

  ; Set ax = ds = 0x1000
  mov     ax,0x1000
  mov     bp,sp
  mov     [ss:bp+0x06],ax

  ; Set the shoadow source segments
  mov     [ss:bp+0x30],ax
  mov     [ss:bp+0x32],ax
  pop     bp

  push    ds
  ; Copied from 2000:E747
  push    2000h
  pop     ds
  mov     DWORD [0xFFF4],0x2F3131F0
  mov     DWORD [0xFFF8],0x392F3131
  mov     DWORD [0xFFFC],0xCFFC0039
  ; mov     ax,1000h                ; Not needed
  ; mov     ds,ax                   ; Not needed

  ; All done!
  pop     ds

  or      al,1                      ; Clear ZF (=abort main loop)
  ret
