; ==============================================================================
; A patch to stop the SMP-disabling from happening on old CPUs and Durons. The
; patch just sets the "SMP capable" bit to 1, and then skips over all the code
; that disables the SMP bit or sets the SMP-disable bit.
;
; Original code:
;   push    ax
;   and     ax, 0FFF0h
;   cmp     ax, 670h
;   pop     ax
;   jnz     SMP_Check_2
;
; Bit 1 (0-based) of [es:di+5] controls whether SMP can happen or not. If it's
;   not set, then SMP will function.
; Bit 0 (0-based) of [es:di+2] indicates whether the CPU supports SMP or not. If
;   it's set, then the CPU can do SMP.
; ==============================================================================

org 0x803D

  mov   BYTE [es:di+2],1
  jmp   0x8075

